package de.uni_passau.fim.PADAS.group3.DataDash.model;
import java.util.List;
import java.util.UUID;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service
public class DatasetService {
    private dataRepository datasetRepository;

    @Autowired
    public DatasetService(dataRepository datasetRepository) {
        this.datasetRepository = datasetRepository;
    }

    public List<Dataset> getAllDatasets() {
        return datasetRepository.findAll();
    }

    public Dataset getDatasetById(UUID id) {
        return datasetRepository.getDatasetById(id);
    }

    public void addDataset(Dataset dataset) {
        datasetRepository.save(dataset);
    }

    public void updateDatasetTitle(UUID id, String title) {
        datasetRepository.getDatasetById(id).setTitle(title);
    }

    public void deleteDataset(UUID id) {
        Dataset dataset = datasetRepository.getDatasetById(id);
        datasetRepository.delete(dataset);
    }

    public List<Dataset> getDatasetsByTitle(String title) {
        return datasetRepository.findByTitle(title);
    }

    public List<Dataset> getDatasetsByTitleLike(String title) {
        return datasetRepository.findByTitleLike(title);
    }

    public List<Dataset> findByDescriptionLike(String description) {
        return datasetRepository.findByDescriptionLike(description);
    }

    public List<Dataset> getDatasetsByAuthorLike(String author) {
        return datasetRepository.findByAuthorLike(author);
    }

    public List<Dataset> getDatasetsByType(Type type) {
        return datasetRepository.findByType(type);
    }

    public List<Dataset> getDatasetsByAbstLike(String abst) {
        return datasetRepository.findByAbstLike(abst);
    }

    public List<Dataset> getDatasetsByRaitingGreaterThan(float raiting) {
        return datasetRepository.findByRaitingGreaterThan(raiting);
    }
}